%define oname spawn

Name:           ocaml-%{oname}
Epoch:          1
Version:        0.13.0
Release:        %mkrel 4
Summary:        Spawning sub-processes

Group:          Development/OCaml
License:        ASL 2.0
URL:            https://github.com/janestreet/%{oname}
Source0:        https://github.com/janestreet/%{oname}/archive/v%{version}.tar.gz

BuildRequires:  ocaml-dune
BuildRequires:  ocaml-compiler
BuildRequires:  ocaml-findlib
BuildRequires:  opam

# Non explicit dependencies needed to run the tests
BuildRequires:  ocaml-fieldslib
BuildRequires:  ocaml-re-devel
BuildRequires:  ocaml-ppx_compare
BuildRequires:  ocaml-ppx_expect
BuildRequires:  ocaml-ppx_inline_test
BuildRequires:  ocaml-ppx_sexp_conv
BuildRequires:  ocaml-sexplib0
BuildRequires:  ocaml-result-devel

%description
Spawning sub-processes

Spawn is a small library exposing only one functionality: spawning sub-process.

It has three main goals:

1. provide missing features of Unix.create_process such as providing a
working directory

2. provide better errors when a system call fails in the
sub-process. For instance if a command is not found, you get a proper
[Unix.Unix_error] exception

3. improve performances by using vfork when available. It is often
claimed that nowadays fork is as fast as vfork, however in practice
fork takes time proportional to the process memory while vfork is
constant time. In application using a lot of memory, vfork can be
thousands of times faster than fork.


%package        devel
Summary:        Development files for %{name}
Group:          Development/OCaml
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and signature files for
developing applications that use %{name}.

%prep
%setup -q -n %{oname}-%{version}

%build
dune build --verbose -p %{oname} %_smp_mflags

%install
opam-installer --prefix=%{buildroot}%{_prefix} --libdir=%{buildroot}%{_libdir}/ocaml %{oname}.install
rm -rf %buildroot/usr/doc

# Makes *.cmxs executable such that they will be stripped.
find %{buildroot} -name '*.cmxs' -exec chmod 0755 {} \;

%check
dune runtest

%files
%license LICENSE.md
%doc README.*
%dir %{_libdir}/ocaml/%{oname}
%{_libdir}/ocaml/%{oname}/META
%{_libdir}/ocaml/%{oname}/*dune*
%{_libdir}/ocaml/%{oname}/*.cmi
%{_libdir}/ocaml/%{oname}/*.cma
%{_libdir}/ocaml/%{oname}/*.a
%{_libdir}/ocaml/%{oname}/*.cmxa
%{_libdir}/ocaml/%{oname}/*.cmxs
%{_libdir}/ocaml/stublibs/dll%{oname}_stubs.so

%files devel
%{_libdir}/ocaml/%{oname}/opam
%{_libdir}/ocaml/%{oname}/*.cmt
%{_libdir}/ocaml/%{oname}/*.cmti
%{_libdir}/ocaml/%{oname}/*.cmx
%{_libdir}/ocaml/%{oname}/*.ml*


%changelog
* Sun Jan 10 2021 pterjan <pterjan> 1:0.13.0-4.mga8
+ Revision: 1670828
- Rebuild to generate ocamlx provides

* Fri Feb 28 2020 umeabot <umeabot> 1:0.13.0-3.mga8
+ Revision: 1552041
- Rebuild for ocaml 4.10.0 final
- Mageia 8 Mass Rebuild

* Tue Jan 28 2020 tv <tv> 1:0.13.0-1.mga8
+ Revision: 1484233
- new release + rebuild for ocaml-4.10

* Wed Oct 24 2018 pterjan <pterjan> 1:0.12.0-1.mga7
+ Revision: 1324932
- Add more BuildRequires for the tests
- Add more BuildRequires for the tests
- Update to 0.12.0

* Tue Oct 23 2018 tv <tv> 1:0.10.0-6.mga7
+ Revision: 1324065
- rebuild with ocaml-4.07.1

* Mon Oct 22 2018 pterjan <pterjan> 1:0.10.0-5.mga7
+ Revision: 1323780
- Rebuild for ocaml 4.07

* Sun Sep 23 2018 umeabot <umeabot> 1:0.10.0-4.mga7
+ Revision: 1299930
- Mageia 7 Mass Rebuild

* Fri Jul 06 2018 daviddavid <daviddavid> 1:0.10.0-3.mga7
+ Revision: 1242052
- rebuild against current ocaml stack
- enable debug package as it should

* Mon Feb 05 2018 daviddavid <daviddavid> 1:0.10.0-2.mga7
+ Revision: 1199043
- fix shared stubs libraries ocaml path

* Mon Jan 15 2018 pterjan <pterjan> 1:0.10.0-1.mga7
+ Revision: 1193512
- imported package ocaml-spawn

